<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SpeedPercentile StructType
 * @subpackage Structs
 */
class SpeedPercentile extends AbstractStructBase
{
    /**
     * The vehiclePercentage
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $vehiclePercentage;
    /**
     * The speedPercentile
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $speedPercentile;
    /**
     * The speedPercentileExtension
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ExtensionType
     */
    public $speedPercentileExtension;
    /**
     * Constructor method for SpeedPercentile
     * @uses SpeedPercentile::setVehiclePercentage()
     * @uses SpeedPercentile::setSpeedPercentile()
     * @uses SpeedPercentile::setSpeedPercentileExtension()
     * @param float $vehiclePercentage
     * @param float $speedPercentile
     * @param \StructType\ExtensionType $speedPercentileExtension
     */
    public function __construct($vehiclePercentage = null, $speedPercentile = null, \StructType\ExtensionType $speedPercentileExtension = null)
    {
        $this
            ->setVehiclePercentage($vehiclePercentage)
            ->setSpeedPercentile($speedPercentile)
            ->setSpeedPercentileExtension($speedPercentileExtension);
    }
    /**
     * Get vehiclePercentage value
     * @return float
     */
    public function getVehiclePercentage()
    {
        return $this->vehiclePercentage;
    }
    /**
     * Set vehiclePercentage value
     * @param float $vehiclePercentage
     * @return \StructType\SpeedPercentile
     */
    public function setVehiclePercentage($vehiclePercentage = null)
    {
        $this->vehiclePercentage = $vehiclePercentage;
        return $this;
    }
    /**
     * Get speedPercentile value
     * @return float
     */
    public function getSpeedPercentile()
    {
        return $this->speedPercentile;
    }
    /**
     * Set speedPercentile value
     * @param float $speedPercentile
     * @return \StructType\SpeedPercentile
     */
    public function setSpeedPercentile($speedPercentile = null)
    {
        $this->speedPercentile = $speedPercentile;
        return $this;
    }
    /**
     * Get speedPercentileExtension value
     * @return \StructType\ExtensionType|null
     */
    public function getSpeedPercentileExtension()
    {
        return $this->speedPercentileExtension;
    }
    /**
     * Set speedPercentileExtension value
     * @param \StructType\ExtensionType $speedPercentileExtension
     * @return \StructType\SpeedPercentile
     */
    public function setSpeedPercentileExtension(\StructType\ExtensionType $speedPercentileExtension = null)
    {
        $this->speedPercentileExtension = $speedPercentileExtension;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SpeedPercentile
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
